import threading
import Queue
import socket
import cPickle
import time
import sys
import select
global s
global rest_data
global debug_mode
global connected
global update_time
global update_freq
update_freq=1000
update_time=time.time()
connected=False
debug_mode=False
rest_data=""
global old_packages
old_packages=[]
global start_time
start_time=time.time()
class communication_thread(threading.Thread):

    def __init__(self, receive_queue,send_queue,kill_event,connected_event,reconnect_event,connected_command,ip_adress_queue):
        self.__receive_queue = receive_queue
        self.__send_queue = send_queue
        self.__s=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.__connected_event=connected_event
        self.__reconnect_event=reconnect_event
        self.__connected_command=connected_command
        self.__ip_adress_queue=ip_adress_queue
        #self.__s.setblocking(0)
        self._stop = threading.Event()
        #self.__ip_adress='10.0.1.1'
        self.__ip_adress='10.42.0.28'
        self.__port=8888
        self.__package_size=4096
        self.__sensors=[]
        self.__connected=False
        self.__kill_event=kill_event
        threading.Thread.__init__(self)
    def run(self):
        """-------------------------put functions here------------------------------"""
        def connect():
            self.__connected_command.wait()
            if not self.__ip_adress_queue.empty():
                ip_adress=self.__ip_adress_queue.get()
            else:
                pass
                ip_adress=self.__ip_adress
            self.__ip_adress_queue.put(ip_adress)
            self.__s.connect((ip_adress , self.__port))
            self.__connected_event.set()
            self.__s.setblocking(0)
            self.__connected=True
        def handle_reqest(package):
            if package[0]=="request_answer":
                handle_answer(package[1])
        def handle_answer(answer):
            wait_for_queue(self.__send_queue)
            if answer[0]=="sensor_values":
                if self.__send_queue.empty():
                    self.__send_queue.put(answer)
                else:
                    list_of_queue_object=[]
                    while not self.__send_queue.empty():
                        item=self.__send_queue.get()
                        if item[0]=="sensor_values":
                            pass
                        else:
                            list_of_queue_object.append(item)
                    for element in list_of_queue_object:
                        self.__send_queue.put(element)
                    self.__send_queue.put(answer)
            reset_queue(self.__send_queue)
        def route_reqests(data_packages):
            if data_packages:
                for element in data_packages:
                    handle_reqest(cPickle.loads(element))
        def update_sensors():
            global start_time
            if time.time()>start_time+10:
                send_data(["request",["update_sensors"]])
                route_reqests(receive_data())
        def receive_data():
            readable, writable, exceptional = select.select([self.__s], [self.__s], [self.__s])
            #test
            while self.__s not in readable:
                readable, writable, exceptional = select.select([self.__s], [self.__s], [self.__s])
            if self.__s in readable:
                complete_data_set=""
                while self.__s in readable:
                    complete_data_set=complete_data_set+self.__s.recv(4096)
                    readable, writable, exceptional = select.select([self.__s], [self.__s], [self.__s])
                packages=[]
                while len(complete_data_set)>0:
                    packages.append(complete_data_set[5:complete_data_set.find("end")])
                    complete_data_set=complete_data_set[complete_data_set.find("end")+3:]
                return packages  
            
        def send_data(data):
            global old_packages
            readable, writable, exceptional = select.select([self.__s], [self.__s], [])
            if old_packages:
                while old_packages and self.__s in writable:
                    self.__s.sendall("start"+cPickle.dumps(old_packages[0])+"end")
                    old_packages=old_packages[1:]
                    readable, writable, exceptional = select.select([self.__s], [self.__s], [])
            if self.__s in writable:
                self.__s.sendall("start"+cPickle.dumps(data)+"end")
            else:
                old_packages.append(data)
        def send_data_new(data):
            print(data)
            self.__s.sendall("start"+cPickle.dumps(data)+"end")
        def kill_connection(reconnect):
            if reconnect:
                send_data(["command",["kill_connection"]])
            else:
                send_data(["command",["kill_connection_without"]])
            time.sleep(1)
            self.__s.close()
            self.__connected==False
            self.__connected_event.clear()
            self.__kill_event.set()
            time.sleep(1)
        def shutdown():
            print("sending shutdown")
            send_data(["command",["shutdown"]])
            time.sleep(3)
            self.__s.close()
            self.__kill_event.set()
        def connection_lost():
            wait_for_queue(self.__send_queue)
            wait_for_queue(self.__receive_queue)
            self.__s.close()
            self.__connected==False
            self.__connected_event.clear()
            self.__s=socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.__reconnect_event.wait()
            self.__s.connect((self.__ip_adress , self.__port))
            self.__connected_event.set()
            self.__s.setblocking(0)
            self.__connected=True
            self.__reconnect_event.clear()
            send_data(["command",["reconnect"]])
            reset_queue(self.__send_queue)
            reset_queue(self.__receive_queue)
            try:
                mainloop()
            except socket.error,e:
                connection_lost()
        def restart():
            send_data(["command",["restart"]])
            time.sleep(5)
            self.__s.close()
            self.__connected==False
            self.__connected_event.clear()
            self.__kill_event.set()
        def stop(self):
            self._stop.set()
        def stopped(self):
            return self._stop.isSet()
        def route_command(data):
            if data[0]=="command":
                send_data(data)
            elif data[0]=="add_sensor":
                send_data(["add_sensor",data[1]])
            elif data[0]=="kill_connection":
                kill_connection(1)
            elif data[0]=="kill_connection_without_reconnect":
                kill_connection(0)
            elif data[0]=="shutdown":
                print("received shutdown")
                shutdown()
            elif data[0]=="restart":
                restart()
            elif data[0]=="restart_program":
                send_data(["command",["restart_program"]])
                mainloop()
            else:
                pass
        def wait_for_queue(queue):
            while queue.get_wanna():
                pass
            queue.set_wanna()
            while queue.get_read():
                pass
            queue.set_read()
            queue.reset_wanna()
        def reset_queue(queue):
            queue.reset_read()
    
        """-------------------------------------------------------------------------"""
        connect()
        def mainloop():
            global update_time,update_freq
            while True:
                if not self.__receive_queue.empty():
                    wait_for_queue(self.__receive_queue)
                    command=self.__receive_queue.get()
                    reset_queue(self.__receive_queue)
                    route_command(command)
                #if time.time()>update_time+1/update_freq:
                update_sensors()
                update_time=time.time()
        try:
            mainloop()
        except socket.error,e:
            connection_lost()